<?php
if ( ! defined( 'ABSPATH' ) ) exit;
?>
<div id="aiomatic-content-generator">
    <p class="aiomatic-form-row">
        <label><strong><?php echo ucwords($post->post_type) . ' ' . esc_html__('Title Idea / Keywords','aiomatic-automatic-ai-content-writer');?></strong></label>
        <input class="coderevolution_gutenberg_input" name="aiomatic_original_title" id="aiomatic_original_title" type="text" value="<?php echo esc_html($post->post_title);?>">
    </p>
    <table class="widefat">
        <tr><td>
        <label for="aiomatic_generate_title"><?php echo esc_html__('Generate A SEO Title','aiomatic-automatic-ai-content-writer');?></label>
</td><td>
        <input type="checkbox" value="1" id="aiomatic_generate_title">
</td></tr><tr><td>
        <label for="aiomatic_generate_title"><?php echo esc_html__('Generate A SEO Meta Description','aiomatic-automatic-ai-content-writer');?></label>
        </td><td>
        <input type="checkbox" value="1" id="aiomatic_generate_meta">
</td></tr><tr><td>
        <label for="aiomatic_generate_description"><?php echo esc_html__('Generate Content','aiomatic-automatic-ai-content-writer');?></label>
        </td><td>
        <input type="checkbox" value="1" id="aiomatic_generate_description">
</td></tr><tr><td>
        <label for="aiomatic_generate_short"><?php echo esc_html__('Generate Short Description (Excerpt)','aiomatic-automatic-ai-content-writer');?></label>
        </td><td>
        <input type="checkbox" value="1" id="aiomatic_generate_short">
</td></tr><tr><td>
        <label for="aiomatic_generate_tags"><?php echo esc_html__('Generate Tags','aiomatic-automatic-ai-content-writer');?></label>
        </td><td>
        <input type="checkbox" value="1" id="aiomatic_generate_tags">
</td></tr><tr><td>
        <button type="button" id="aiomatic_show_more" class="button"><?php echo esc_html__('Toggle Advanced Options','aiomatic-automatic-ai-content-writer');?></button>
</td></tr><tr class="aiomatic_toggle_me aiomatic_none"><td>
        <label for="aiomatic_ai_model"><?php echo esc_html__('AI Model','aiomatic-automatic-ai-content-writer');?></label>
        </td><td>
<?php 
$all_models = aiomatic_get_all_models(true);
?>
<select class="coderevolution_gutenberg_input" autocomplete="off" id="aiomatic_ai_model" name="aiomatic_ai_model" class="cr_width_full">
<?php
foreach($all_models as $modelx)
{
   echo '<option value="' . $modelx .'"';
   echo '>' . esc_html($modelx) . '</option>';
}
?>
</select>   
</td></tr><tr class="aiomatic_toggle_me aiomatic_none"><td>
        <label for="aiomatic_title_prompt"><?php echo ucwords($post->post_type) . ' ' .esc_html__('Title Prompt','aiomatic-automatic-ai-content-writer');?></label><div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
<div class="bws_hidden_help_text cr_min_260px">
    <?php
        echo esc_html__("You can use the following shortcodes here: %%post_title_idea%%, %%post_title%%, %%post_excerpt%%, %%post_content%%, %%post_type%%", 'aiomatic-automatic-ai-content-writer');
        ?>
    </div>
</div>
        </td><td>
        <textarea class="coderevolution_gutenberg_input" name="aiomatic_title_prompt" id="aiomatic_title_prompt"><?php echo sprintf( wp_kses( __( 'Create a captivating and concise SEO title in English for your WordPress %s: "%s". Boost its search engine visibility with relevant keywords for maximum impact.', 'aiomatic-automatic-ai-content-writer'), array(  'a' => array( 'href' => array(), 'target' => array() ) ) ), $post->post_type, '%%post_title_idea%%' );?></textarea>
</td></tr><tr class="aiomatic_toggle_me aiomatic_none"><td>
        <label for="aiomatic_seo_prompt"><?php echo ucwords($post->post_type) . ' ' .esc_html__('SEO Meta Description Prompt','aiomatic-automatic-ai-content-writer');?></label><div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
<div class="bws_hidden_help_text cr_min_260px">
    <?php
        echo esc_html__("You can use the following shortcodes here: %%post_title_idea%%, %%post_title%%, %%post_excerpt%%, %%post_content%%, %%post_type%%", 'aiomatic-automatic-ai-content-writer');
        ?>
    </div>
</div>
        </td><td>
        <textarea class="coderevolution_gutenberg_input" name="aiomatic_seo_prompt" id="aiomatic_seo_prompt"><?php echo sprintf( wp_kses( __( 'Craft an enticing and succinct meta description in English for your WordPress %s: "%s". Emphasize the notable features and advantages in just 155 characters, incorporating relevant keywords to optimize its SEO performance.', 'aiomatic-automatic-ai-content-writer'), array(  'a' => array( 'href' => array(), 'target' => array() ) ) ), $post->post_type, '%%post_title_idea%%' );?></textarea>
</td></tr><tr class="aiomatic_toggle_me aiomatic_none"><td>
        <label for="aiomatic_content_prompt"><?php echo ucwords($post->post_type) . ' ' .esc_html__('Content Prompt','aiomatic-automatic-ai-content-writer');?></label><div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
<div class="bws_hidden_help_text cr_min_260px">
    <?php
        echo esc_html__("You can use the following shortcodes here: %%post_title_idea%%, %%post_title%%, %%post_excerpt%%, %%post_content%%, %%post_type%%", 'aiomatic-automatic-ai-content-writer');
        ?>
    </div>
</div>
        </td><td>
        <textarea class="coderevolution_gutenberg_input" name="aiomatic_content_prompt" id="aiomatic_content_prompt"><?php echo sprintf( wp_kses( __( 'Create a captivating and comprehensive English description for your WordPress %s: "%s". Dive into specific details, highlighting its unique features of this subject, if possible, benefits, and the value it brings. Craft a compelling narrative around the %s that captivates the audience. Use HTML for formatting, include unnumbered lists and bold. Writing Style: Creative. Tone: Neutral.', 'aiomatic-automatic-ai-content-writer'), array(  'a' => array( 'href' => array(), 'target' => array() ) ) ), $post->post_type, '%%post_title_idea%%', $post->post_type );?></textarea>
</td></tr><tr class="aiomatic_toggle_me aiomatic_none"><td>
        <label for="aiomatic_short_prompt"><?php echo ucwords($post->post_type) . ' ' .esc_html__('Short Description Prompt','aiomatic-automatic-ai-content-writer');?></label><div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
<div class="bws_hidden_help_text cr_min_260px">
    <?php
        echo esc_html__("You can use the following shortcodes here: %%post_title_idea%%, %%post_title%%, %%post_excerpt%%, %%post_content%%, %%post_type%%", 'aiomatic-automatic-ai-content-writer');
        ?>
    </div>
</div>
        </td><td>
        <textarea class="coderevolution_gutenberg_input" name="aiomatic_short_prompt" id="aiomatic_short_prompt"><?php echo sprintf( wp_kses( __( 'Write a captivating and succinct English summary for the WordPress %s: "%s", accentuating its pivotal features, advantages, and distinctive qualities.', 'aiomatic-automatic-ai-content-writer'), array(  'a' => array( 'href' => array(), 'target' => array() ) ) ), $post->post_type, '%%post_title_idea%%' );?></textarea>
</td></tr><tr class="aiomatic_toggle_me aiomatic_none"><td>
        <label for="aiomatic_tag_prompt"><?php echo ucwords($post->post_type) . ' ' .esc_html__('Tags Prompt','aiomatic-automatic-ai-content-writer');?></label><div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
<div class="bws_hidden_help_text cr_min_260px">
    <?php
        echo esc_html__("You can use the following shortcodes here: %%post_title_idea%%, %%post_title%%, %%post_excerpt%%, %%post_content%%, %%post_type%%", 'aiomatic-automatic-ai-content-writer');
        ?>
    </div>
</div>
        </td><td>
        <textarea class="coderevolution_gutenberg_input" name="aiomatic_tag_prompt" id="aiomatic_tag_prompt"><?php echo sprintf( wp_kses( __( 'Suggest a series of pertinent keywords in English for your WordPress %s: "%s". These keywords should be closely connected to the %s, optimizing its visibility. Please present the keywords in a comma-separated format without using symbols like -, #, etc.', 'aiomatic-automatic-ai-content-writer'), array(  'a' => array( 'href' => array(), 'target' => array() ) ) ), $post->post_type, '%%post_title_idea%%', $post->post_type );?></textarea>
</td></tr>
    </table>
    <br/>
    <button type="button" id="aiomatic_ai_content_generator" class="button button-primary"><?php echo esc_html__('Generate Using AI','aiomatic-automatic-ai-content-writer');?></button>
    <br/>
    <br/>
    <div id="ai-generator-status">

    </div>
</div>